diff -r -uw -N irrlicht/source/Irrlicht/CGUIContextMenu.cpp irrlicht_multipatch/source/Irrlicht/CGUIContextMenu.cpp
--- irrlicht/source/Irrlicht/CGUIContextMenu.cpp	2006-11-11 09:29:20.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CGUIContextMenu.cpp	2006-11-30 12:39:52.000000000 +0100
@@ -51,7 +51,7 @@
 
 
 //! Adds a menu item.
-s32 CGUIContextMenu::addItem(const wchar_t* text, s32 id, bool enabled, bool hasSubMenu)
+s32 CGUIContextMenu::addItem(const wchar_t* text, s32 id, bool enabled, bool hasSubMenu, bool checked)
 {
 	SItem s;
 	s.Enabled = enabled;
@@ -59,6 +59,7 @@
 	s.IsSeparator = (text == 0);
 	s.SubMenu = 0;
 	s.CommandId = id;
+	s.IsChecked = checked;
 
 	if (hasSubMenu)
 	{
@@ -125,6 +126,27 @@
 	Items[idx].Enabled = enabled;
 }
 
+//! Sets if the menu item should be checked.
+void CGUIContextMenu::setItemChecked(s32 idx, bool checked)
+{
+	if (idx < 0 || idx >= (s32)Items.size())
+		return;
+
+	Items[idx].IsChecked = checked;
+}
+
+//! Returns if a menu item is checked
+bool CGUIContextMenu::isItemChecked(s32 idx)
+{
+	if (idx < 0 || idx >= (s32)Items.size())
+	{
+		_IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX;
+		return false;
+	}
+
+	_IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX;
+	return Items[idx].IsChecked;
+}
 
 //! Removes a menu item
 void CGUIContextMenu::removeItem(s32 idx)
@@ -397,6 +419,15 @@
 					skin->getColor(c), true, true, clip);
 			}
 
+			// draw checked symbol
+			if (Items[i].IsChecked && defaultFont)
+			{
+				core::rect<s32> r = rect;
+				r.UpperLeftCorner.X = r.LowerRightCorner.X - 45;
+
+				defaultFont->draw(GUI_ICON_CHECK_BOX_CHECKED, r, 
+					skin->getColor(c), true, true, clip);
+			}
 		}
 	}
 
diff -r -uw -N irrlicht/source/Irrlicht/CGUIContextMenu.h irrlicht_multipatch/source/Irrlicht/CGUIContextMenu.h
--- irrlicht/source/Irrlicht/CGUIContextMenu.h	2006-11-11 09:29:20.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CGUIContextMenu.h	2006-11-30 12:37:42.000000000 +0100
@@ -32,7 +32,7 @@
 
 		//! Adds a menu item.
 		virtual s32 addItem(const wchar_t* text, s32 commandid, bool enabled=true,
-			bool hasSubMenu=false);
+			bool hasSubMenu=false, bool checked=false);
 
 		//! Adds a separator item to the menu
 		virtual void addSeparator();
@@ -49,6 +49,12 @@
 		//! Sets if the menu item should be enabled.
 		virtual void setItemEnabled(s32 idx, bool enabled);
 
+		//! Returns if a menu item is checked
+		virtual bool isItemChecked(s32 idx);
+
+		//! Sets if the menu item should be checked.
+		virtual void setItemChecked(s32 idx, bool checked);
+
 		//! Removes a menu item
 		virtual void removeItem(s32 idx);
 
@@ -84,6 +90,7 @@
 			core::stringw Text;
 			bool IsSeparator;
 			bool Enabled;
+			bool IsChecked;
 			core::dimension2d<s32> Dim;
 			s32 PosY;
 			CGUIContextMenu* SubMenu;
diff -r -uw -N irrlicht/source/Irrlicht/CGUIEditBox.cpp irrlicht_multipatch/source/Irrlicht/CGUIEditBox.cpp
--- irrlicht/source/Irrlicht/CGUIEditBox.cpp	2006-11-11 09:29:20.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CGUIEditBox.cpp	2006-12-01 13:18:04.000000000 +0100
@@ -399,6 +399,12 @@
 				MarkBegin = 0;
 				MarkEnd = 0;
 			}
+			SEvent e;
+			e.EventType = EET_GUI_EVENT;
+			e.GUIEvent.Caller = this;
+			e.GUIEvent.EventType = EGET_EDITBOX_KEY_PRESS;
+			Parent->OnEvent(e);
+
 		}
 		break;
 	}
diff -r -uw -N irrlicht/source/Irrlicht/CGUIWindow.cpp irrlicht_multipatch/source/Irrlicht/CGUIWindow.cpp
--- irrlicht/source/Irrlicht/CGUIWindow.cpp	2006-11-11 09:29:22.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CGUIWindow.cpp	2006-11-30 12:31:56.000000000 +0100
@@ -77,6 +77,12 @@
 		{
 			if (event.GUIEvent.Caller == CloseButton)
 			{
+				SEvent levent;
+				levent.EventType = EET_GUI_EVENT;
+				levent.GUIEvent.Caller = this;
+				levent.GUIEvent.EventType = EGET_WINDOW_CLOSED;
+				Parent->OnEvent(levent);
+
 				remove();
 				return true;
 			}
diff -r -uw -N irrlicht/source/Irrlicht/CIrrDeviceWin32.cpp irrlicht_multipatch/source/Irrlicht/CIrrDeviceWin32.cpp
--- irrlicht/source/Irrlicht/CIrrDeviceWin32.cpp	2006-10-15 08:48:48.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CIrrDeviceWin32.cpp	2006-12-01 10:38:54.000000000 +0100
@@ -31,6 +31,12 @@
 			u32 bits, bool fullscreen, bool stencilbuffer, io::IFileSystem* io,
 			bool pureSoftware, bool highPrecisionFPU, bool vsync, bool antiAlias);
 
+		IVideoDriver* createDirectX9DriverMultihead(const core::array<core::dimension2d<s32> > & screenSize, core::array<HWND> window,
+													u32 bits, bool fullscreen, bool stencilbuffer,
+													io::IFileSystem* io, bool pureSoftware, bool highPrecisionFPU, bool vsync, bool antiAlias);
+
+		int getDirectX9MultiheadAdapterCount();
+
 		IVideoDriver* createOpenGLDriver(const core::dimension2d<s32>& screenSize, HWND window, 
 			u32 bits, bool fullscreen, bool stencilBuffer, io::IFileSystem* io,
 			bool vsync, bool antiAlias);
@@ -84,6 +90,12 @@
 
 	switch (message) 
 	{
+	case WM_CLOSE:
+		dev = getDeviceFromHWnd(hWnd); 
+		if (dev) 
+			dev->closeDevice();
+		return 0;
+
 	case WM_PAINT:
 		{
 			PAINTSTRUCT ps;
@@ -270,7 +282,7 @@
 				 IEventReceiver* receiver,
 				 HWND externalWindow,
 				 const char* version)
-: CIrrDeviceStub(version, receiver), HWnd(0), ChangedToFullScreen(false),
+: CIrrDeviceStub(version, receiver), ChangedToFullScreen(false),
 	Win32CursorControl(0), IsNonNTWindows(false), Resized(false),
 	FullScreen(fullscreen), ExternalWindow(false)
 {
@@ -287,6 +299,11 @@
 	setDebugName("CIrrDeviceWin32");	
 	#endif
 
+	m_adapterCount = 0;
+
+	//add a null device
+	mHWnd.push_back(NULL);
+
 	if (driverType != video::EDT_NULL && externalWindow==0)
 	{
 		// create the window, only if we do not use the null device
@@ -297,7 +314,12 @@
 
 		WNDCLASSEX wcex;
 		wcex.cbSize		= sizeof(WNDCLASSEX); 
+
+		if(driverType == video::EDT_DIRECT3D9_MULTIHEAD && fullscreen)
+			wcex.style			= 0;
+		else
 		wcex.style		= CS_HREDRAW | CS_VREDRAW;
+
 		wcex.lpfnWndProc	= (WNDPROC)WndProc;
 		wcex.cbClsExtra		= 0;
 		wcex.cbWndExtra		= 0;
@@ -339,26 +361,62 @@
 		{
 			windowLeft = 0;
 			windowTop = 0;
+
+			if(driverType == video::EDT_DIRECT3D9_MULTIHEAD)
+			{
+				m_adapterCount = video::getDirectX9MultiheadAdapterCount();
+				if(m_adapterCount <= 1)
+				{
+					os::Printer::log("Could not initialise directx9 multihead device.", ELL_WARNING);
+					driverType = video::EDT_DIRECT3D9;
+				}
+				for(s32 idx = 1; idx < m_adapterCount; idx++)
+				{
+					mHWnd.push_back(NULL);
+				}
+			}
+		}
+		else
+		{
+			if(driverType == video::EDT_DIRECT3D9_MULTIHEAD)
+			{
+				//we do not support multihead in window mode
+				driverType = video::EDT_DIRECT3D9;
+			}
 		}
 
+		if(m_adapterCount <= 1)
+		{
 		// create window
-
-		HWnd = CreateWindow( ClassName, "", style, windowLeft, windowTop, 
+			mHWnd[0] = CreateWindow( ClassName, "", style, windowLeft, windowTop, 
 					realWidth, realHeight,	NULL, NULL, hInstance, NULL);
 
-		ShowWindow(HWnd , SW_SHOW);
-		UpdateWindow(HWnd);
+			ShowWindow(mHWnd[0] , SW_SHOW);
+			UpdateWindow(mHWnd[0]);
 
 		// fix ugly ATI driver bugs. Thanks to ariaci
-		MoveWindow(HWnd, windowLeft, windowTop, realWidth, realHeight, TRUE);
+			MoveWindow(mHWnd[0], windowLeft, windowTop, realWidth, realHeight, TRUE);
+			m_multiHead = false;
+		}
+		else if(m_adapterCount > 1)
+		{
+			for(s32 idx = 0; idx < m_adapterCount; idx++)
+			{
+				mHWnd[idx] = CreateWindow( ClassName, "", style, CW_USEDEFAULT, CW_USEDEFAULT, 
+									CW_USEDEFAULT, CW_USEDEFAULT, mHWnd[0], NULL, hInstance, NULL);
+				ShowWindow(mHWnd[idx] , SW_SHOW);
+				UpdateWindow(mHWnd[idx]);
+			}
+			m_multiHead = true;
+		}
 	}
 
 	// attach external window
 	if (externalWindow)
 	{
-		HWnd = externalWindow;
+		mHWnd[0] = externalWindow;
 		RECT r;
-		GetWindowRect(HWnd, &r);
+		GetWindowRect(mHWnd[0], &r);
 		windowSize.Width = r.right - r.left;
 		windowSize.Height = r.bottom - r.top;
 		fullscreen = false;
@@ -367,7 +425,7 @@
 
 	// create cursor control
 
-	Win32CursorControl = new CCursorControl(windowSize, HWnd, fullscreen);
+	Win32CursorControl = new CCursorControl(windowSize, mHWnd[0], fullscreen);
 	CursorControl = Win32CursorControl;
 
 	// create driver
@@ -380,12 +438,15 @@
 
 	SEnvMapper em;
 	em.irrDev = this;
-	em.hWnd = HWnd;
+	em.hWnd = mHWnd[0];
 	EnvMap.push_back(em);
 
+	if(driverType != video::EDT_DIRECT3D9_MULTIHEAD)
+	{
 	// set this as active window
-	SetActiveWindow(HWnd);
-	SetForegroundWindow(HWnd);
+		SetActiveWindow(mHWnd[0]);
+		SetForegroundWindow(mHWnd[0]);
+	}
 }
 
 
@@ -397,7 +458,7 @@
 
 	irr::core::list<SEnvMapper>::Iterator it = EnvMap.begin();
 	for (; it!= EnvMap.end(); ++it)
-		if ((*it).hWnd == HWnd)
+		if ((*it).hWnd == mHWnd[0])
 		{
 			EnvMap.erase(it);
 			break;
@@ -405,6 +466,9 @@
 
 	if (ChangedToFullScreen)
 		ChangeDisplaySettings(NULL,0);
+
+	if(m_multiHead)
+		closeDevice();
 }
 
 
@@ -423,7 +487,7 @@
 	{
 	case video::EDT_DIRECT3D8:
 		#ifdef _IRR_COMPILE_WITH_DIRECT3D_8_
-		VideoDriver = video::createDirectX8Driver(windowSize, HWnd, bits, fullscreen, 
+		VideoDriver = video::createDirectX8Driver(windowSize, mHWnd[0], bits, fullscreen, 
 			stencilbuffer, FileSystem, false, highPrecisionFPU, vsync, antiAlias);
 		if (!VideoDriver)
 		{
@@ -437,7 +501,7 @@
 
 	case video::EDT_DIRECT3D9:
 		#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
-		VideoDriver = video::createDirectX9Driver(windowSize, HWnd, bits, fullscreen, 
+		VideoDriver = video::createDirectX9Driver(windowSize, mHWnd[0], bits, fullscreen, 
 			stencilbuffer, FileSystem, false, highPrecisionFPU, vsync, antiAlias);
 		if (!VideoDriver)
 		{
@@ -449,11 +513,34 @@
 
 		break;	
 	
+	case video::EDT_DIRECT3D9_MULTIHEAD:
+		#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
+		{
+			core::array<core::dimension2d<s32> > windowSizes;
+			for(s32 idx = 0; idx < m_adapterCount; ++idx)
+				windowSizes.push_back(windowSize);
+
+			VideoDriver = video::createDirectX9DriverMultihead(windowSizes, mHWnd, bits, fullscreen, 
+															stencilbuffer, FileSystem, false, highPrecisionFPU, vsync, antiAlias);
+		}
+		#endif
+
+		if (!VideoDriver)
+		{
+			#ifdef _IRR_COMPILE_WITH_DIRECT3D_9_
+			os::Printer::log("Could not create DirectX9 Multihead Driver.", ELL_ERROR);
+			#else
+			os::Printer::log("DIRECT3D9 Driver was not compiled into this dll. Try another one.", ELL_ERROR);
+			#endif
+		}
+
+		break;	
+
 	case video::EDT_OPENGL:
 
 		#ifdef _IRR_COMPILE_WITH_OPENGL_
 		if (fullscreen)	switchToFullScreen(windowSize.Width, windowSize.Height, bits);
-		VideoDriver = video::createOpenGLDriver(windowSize, HWnd, bits, fullscreen, stencilbuffer, FileSystem,
+		VideoDriver = video::createOpenGLDriver(windowSize, mHWnd[0], bits, fullscreen, stencilbuffer, FileSystem,
 			vsync, antiAlias);
 		if (!VideoDriver)
 		{
@@ -496,8 +583,8 @@
 	{
 		TranslateMessage(&msg);
 
-		if (ExternalWindow && msg.hwnd == HWnd)
-			WndProc(HWnd, msg.message, msg.wParam, msg.lParam);
+		if (ExternalWindow && msg.hwnd == mHWnd[0])
+			WndProc(mHWnd[0], msg.message, msg.wParam, msg.lParam);
 		else
 			DispatchMessage(&msg);
 
@@ -519,7 +606,7 @@
 		return;
 
 	RECT r;
-	GetClientRect(HWnd, &r);
+	GetClientRect(mHWnd[0], &r);
 
 	char tmp[255];
 
@@ -553,10 +640,10 @@
 	if (IsNonNTWindows)
 	{
 		core::stringc s = text;
-		SetWindowTextA(HWnd, s.c_str());
+		SetWindowTextA(mHWnd[0], s.c_str());
 	}
 	else
-		SetWindowTextW(HWnd, text);
+		SetWindowTextW(mHWnd[0], text);
 }
 
 
@@ -564,7 +651,7 @@
 //! presents a surface in the client area
 void CIrrDeviceWin32::present(video::IImage* image, s32 windowId, core::rect<s32>* src )
 {
-	HWND hwnd = HWnd;
+	HWND hwnd = mHWnd[0];
 	if ( windowId )
 		hwnd = (HWND)windowId;
 
@@ -614,7 +701,7 @@
 //! notifies the device that it should close itself
 void CIrrDeviceWin32::closeDevice()
 {
-	DestroyWindow(HWnd); 	//PostQuitMessage(0);
+	DestroyWindow(mHWnd[0]); 	//PostQuitMessage(0);
 }
 
 
@@ -622,7 +709,7 @@
 //! returns if window is active. if not, nothing need to be drawn
 bool CIrrDeviceWin32::isWindowActive()
 {
-	bool ret = (GetActiveWindow() == HWnd);
+	bool ret = (GetActiveWindow() == mHWnd[0]);
 	_IRR_IMPLEMENT_MANAGED_MARSHALLING_BUGFIX;	
 	return ret;
 }
@@ -840,7 +927,7 @@
 	else
 		style = WS_THICKFRAME | WS_SYSMENU | WS_CAPTION | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_MAXIMIZEBOX;
 
-	if (!SetWindowLong(HWnd, GWL_STYLE, style))
+	if (!SetWindowLong(mHWnd[0], GWL_STYLE, style))
 		os::Printer::log("Could not change window style.");
 
 	RECT clientSize;
@@ -857,7 +944,7 @@
 	s32 windowLeft = (GetSystemMetrics(SM_CXSCREEN) - realWidth) / 2;
 	s32 windowTop = (GetSystemMetrics(SM_CYSCREEN) - realHeight) / 2;
 
-	SetWindowPos(HWnd, HWND_TOP, windowLeft, windowTop, realWidth, realHeight, 
+	SetWindowPos(mHWnd[0], HWND_TOP, windowLeft, windowTop, realWidth, realHeight, 
 		SWP_FRAMECHANGED | SWP_NOMOVE | SWP_SHOWWINDOW);
 }
 
@@ -889,6 +976,10 @@
 	return dev;
 }
 
+IRRLICHT_API s32 IRRCALLCONV getMultiHeadAdapterCountDX9()
+{
+	return (s32) video::getDirectX9MultiheadAdapterCount();
+}
 
 } // end namespace 
 
diff -r -uw -N irrlicht/source/Irrlicht/CIrrDeviceWin32.h irrlicht_multipatch/source/Irrlicht/CIrrDeviceWin32.h
--- irrlicht/source/Irrlicht/CIrrDeviceWin32.h	2006-08-03 19:43:54.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CIrrDeviceWin32.h	2006-11-30 17:23:56.000000000 +0100
@@ -181,7 +181,10 @@
 
 		void resizeIfNecessary();
 
-		HWND HWnd;
+		//HWND HWnd;
+		core::array<HWND> mHWnd;
+		bool m_multiHead;
+		s32  m_adapterCount;
 
 		bool ChangedToFullScreen;
 		bool FullScreen;
diff -r -uw -N irrlicht/source/Irrlicht/CMeshManipulator.cpp irrlicht_multipatch/source/Irrlicht/CMeshManipulator.cpp
--- irrlicht/source/Irrlicht/CMeshManipulator.cpp	2006-08-29 08:13:04.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CMeshManipulator.cpp	2006-11-29 22:02:38.000000000 +0100
@@ -21,7 +21,7 @@
 //! visual studio 6.0 didn't like it.
 template<class VTXTYPE>
 inline void recalculateNormalsT_Flat(VTXTYPE* v, int vtxcnt,
-					u16* idx, int idxcnt)
+					u32* idx, int idxcnt)
 {
 	for (int i=0; i<idxcnt; i+=3)
 	{
@@ -34,7 +34,7 @@
 
 template<class VTXTYPE>
 inline void recalculateNormalsT_Smooth(VTXTYPE* v, int vtxcnt,
-					u16* idx, int idxcnt)
+					u32* idx, int idxcnt)
 {
 	s32 i;
 
@@ -65,7 +65,7 @@
 template<class VERTEXTYPE>
 inline void makePlanarMappingT(VERTEXTYPE *v,
 				   int vtxcnt,
-				   u16* idx, int idxcnt, f32 resolution)
+				   u32* idx, int idxcnt, f32 resolution)
 {
 	for (int i=0; i<idxcnt; i+=3)
 	{
@@ -127,7 +127,7 @@
 	{
 		IMeshBuffer* buffer = mesh->getMeshBuffer(b);
 		s32 idxcnt = buffer->getIndexCount();
-		u16* idx = buffer->getIndices();
+		u32* idx = buffer->getIndices();
 		s32 tmp;
 
 		for (s32 i=0; i<idxcnt; i+=3)
@@ -230,7 +230,7 @@
 
 	s32 vtxcnt = buffer->getVertexCount();
 	s32 idxcnt = buffer->getIndexCount();
-	u16* idx = buffer->getIndices();
+	u32* idx = buffer->getIndices();
 
 	switch(buffer->getVertexType())
 	{
@@ -411,7 +411,7 @@
 	{
 		s32 vtxCnt = mesh->getMeshBuffer(b)->getVertexCount();
 		s32 idxCnt = mesh->getMeshBuffer(b)->getIndexCount();
-		const u16* idx = mesh->getMeshBuffer(b)->getIndices();
+		const u32* idx = mesh->getMeshBuffer(b)->getIndices();
 
 		switch(mesh->getMeshBuffer(b)->getVertexType())
 		{
@@ -501,7 +501,7 @@
 		IMeshBuffer* buffer = mesh->getMeshBuffer(b);
 		s32 vtxcnt = buffer->getVertexCount();
 		s32 idxcnt = buffer->getIndexCount();
-		u16* idx = buffer->getIndices();
+		u32* idx = buffer->getIndices();
 
 		switch(buffer->getVertexType())
 		{
@@ -542,7 +542,7 @@
 	for (s32 b=0; b<meshBufferCount; ++b)
 	{
 		s32 idxCnt = mesh->getMeshBuffer(b)->getIndexCount();
-		const u16* idx = mesh->getMeshBuffer(b)->getIndices();
+		const u32* idx = mesh->getMeshBuffer(b)->getIndices();
 
 		switch(mesh->getMeshBuffer(b)->getVertexType())
 		{
@@ -639,7 +639,7 @@
 	for (b=0; b<meshBufferCount; ++b)
 	{
 		s32 idxCnt = mesh->getMeshBuffer(b)->getIndexCount();
-		const u16* idx = mesh->getMeshBuffer(b)->getIndices();
+		const u32* idx = mesh->getMeshBuffer(b)->getIndices();
 
 		SMeshBufferTangents* buffer = new SMeshBufferTangents();
 		buffer->Material = mesh->getMeshBuffer(b)->getMaterial();
@@ -698,7 +698,7 @@
 	{
 		s32 idxCnt = clone->getMeshBuffer(b)->getIndexCount();
 
-		u16* idx = clone->getMeshBuffer(b)->getIndices();
+		u32* idx = clone->getMeshBuffer(b)->getIndices();
 		video::S3DVertexTangents* v =
 			(video::S3DVertexTangents*)clone->getMeshBuffer(b)->getVertices();
 
diff -r -uw -N irrlicht/source/Irrlicht/CNullDriver.cpp irrlicht_multipatch/source/Irrlicht/CNullDriver.cpp
--- irrlicht/source/Irrlicht/CNullDriver.cpp	2006-11-01 08:01:48.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CNullDriver.cpp	2006-12-05 11:49:27.000000000 +0100
@@ -208,7 +208,7 @@
 
 
 //! queries the features of the driver, returns true if feature is available
-bool CNullDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature)
+bool CNullDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
 {
 	return false;
 }
@@ -467,7 +467,7 @@
 
 
 //! draws a vertex primitive list
-void CNullDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+void CNullDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
 {
 	PrimitivesDrawn += primitiveCount;
 }
@@ -475,7 +475,7 @@
 
 
 //! draws an indexed triangle list
-inline void CNullDriver::drawIndexedTriangleList(const S3DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+inline void CNullDriver::drawIndexedTriangleList(const S3DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	drawVertexPrimitiveList(vertices, vertexCount, indexList, triangleCount, EVT_STANDARD, scene::EPT_TRIANGLES);
 }
@@ -483,7 +483,7 @@
 
 
 //! draws an indexed triangle list
-inline void CNullDriver::drawIndexedTriangleList(const S3DVertex2TCoords* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount)
+inline void CNullDriver::drawIndexedTriangleList(const S3DVertex2TCoords* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	drawVertexPrimitiveList(vertices, vertexCount, indexList, triangleCount, EVT_2TCOORDS, scene::EPT_TRIANGLES);
 }
@@ -491,7 +491,7 @@
 
 //! Draws an indexed triangle list.
 inline void CNullDriver::drawIndexedTriangleList(const S3DVertexTangents* vertices,
-	s32 vertexCount, const u16* indexList, s32 triangleCount)
+	s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	drawVertexPrimitiveList(vertices, vertexCount, indexList, triangleCount, EVT_TANGENTS, scene::EPT_TRIANGLES);
 }
@@ -500,7 +500,7 @@
 
 //! Draws an indexed triangle fan.
 inline void CNullDriver::drawIndexedTriangleFan(const S3DVertex* vertices,
-	s32 vertexCount, const u16* indexList, s32 triangleCount)
+	s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	drawVertexPrimitiveList(vertices, vertexCount, indexList, triangleCount, EVT_STANDARD, scene::EPT_TRIANGLE_FAN);
 }
@@ -509,7 +509,7 @@
 
 //! Draws an indexed triangle fan.
 inline void CNullDriver::drawIndexedTriangleFan(const S3DVertex2TCoords* vertices,
-	s32 vertexCount, const u16* indexList, s32 triangleCount)
+	s32 vertexCount, const u32* indexList, s32 triangleCount)
 {
 	drawVertexPrimitiveList(vertices, vertexCount, indexList, triangleCount, EVT_2TCOORDS, scene::EPT_TRIANGLE_FAN);
 }
diff -r -uw -N irrlicht/source/Irrlicht/CNullDriver.h irrlicht_multipatch/source/Irrlicht/CNullDriver.h
--- irrlicht/source/Irrlicht/CNullDriver.h	2006-11-01 08:01:48.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CNullDriver.h	2006-12-05 11:49:34.000000000 +0100
@@ -36,7 +36,7 @@
 		virtual bool endScene( s32 windowId = 0, core::rect<s32>* sourceRect=0 );
 
 		//! queries the features of the driver, returns true if feature is available
-		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature);
+		virtual bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
 
 		//! sets transformation
 		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
@@ -70,25 +70,25 @@
 		virtual const core::rect<s32>& getViewPort() const;
 
 		//! draws a vertex primitive list
-		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+		virtual void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
 
 		//! draws an indexed triangle list
-		virtual void drawIndexedTriangleList(const S3DVertex* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount);
+		virtual void drawIndexedTriangleList(const S3DVertex* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		//! draws an indexed triangle list
-		virtual void drawIndexedTriangleList(const S3DVertex2TCoords* vertices, s32 vertexCount, const u16* indexList, s32 triangleCount);
+		virtual void drawIndexedTriangleList(const S3DVertex2TCoords* vertices, s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		//! Draws an indexed triangle list.
 		virtual void drawIndexedTriangleList(const S3DVertexTangents* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount);
+			s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		//! Draws an indexed triangle fan.
 		virtual void drawIndexedTriangleFan(const S3DVertex* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount);
+			s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		//! Draws an indexed triangle list.
 		virtual void drawIndexedTriangleFan(const S3DVertex2TCoords* vertices,
-			s32 vertexCount, const u16* indexList, s32 triangleCount);
+			s32 vertexCount, const u32* indexList, s32 triangleCount);
 
 		//! Draws a 3d line.
 		virtual void draw3DLine(const core::vector3df& start,
diff -r -uw -N irrlicht/source/Irrlicht/COpenGLDriver.cpp irrlicht_multipatch/source/Irrlicht/COpenGLDriver.cpp
--- irrlicht/source/Irrlicht/COpenGLDriver.cpp	2006-11-27 16:44:10.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/COpenGLDriver.cpp	2006-12-05 11:48:31.000000000 +0100
@@ -83,7 +83,7 @@
 		0,				// Shift Bit Ignored
 		0,				// No Accumulation Buffer
 		0, 0, 0, 0,			// Accumulation Bits Ignored
-		24,				// Z-Buffer (Depth Buffer)
+		16,				// Z-Buffer (Depth Buffer)
 		StencilBuffer ? 1 : 0,		// Stencil Buffer
 		0,				// No Auxiliary Buffer
 		PFD_MAIN_PLANE,			// Main Drawing Layer
@@ -814,7 +814,7 @@
 
 
 //! draws a vertex primitive list
-void COpenGLDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
+void COpenGLDriver::drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType)
 {
 	if (!primitiveCount || !vertexCount)
 		return;
@@ -922,31 +922,31 @@
 			glDrawArrays(GL_POINTS, 0, primitiveCount);
 			break;
 		case scene::EPT_LINE_STRIP:
-			glDrawElements(GL_LINE_STRIP, primitiveCount+1, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_LINE_STRIP, primitiveCount+1, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_LINE_LOOP:
-			glDrawElements(GL_LINE_LOOP, primitiveCount, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_LINE_LOOP, primitiveCount, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_LINES:
-			glDrawElements(GL_LINES, primitiveCount*2, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_LINES, primitiveCount*2, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_TRIANGLE_STRIP:
-			glDrawElements(GL_TRIANGLE_STRIP, primitiveCount+2, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_TRIANGLE_STRIP, primitiveCount+2, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_TRIANGLE_FAN:
-			glDrawElements(GL_TRIANGLE_FAN, primitiveCount+2, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_TRIANGLE_FAN, primitiveCount+2, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_TRIANGLES:
-			glDrawElements(GL_TRIANGLES, primitiveCount*3, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_TRIANGLES, primitiveCount*3, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_QUAD_STRIP:
-			glDrawElements(GL_QUAD_STRIP, primitiveCount*2+2, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_QUAD_STRIP, primitiveCount*2+2, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_QUADS:
-			glDrawElements(GL_QUADS, primitiveCount*4, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_QUADS, primitiveCount*4, GL_UNSIGNED_INT, indexList);
 			break;
 		case scene::EPT_POLYGON:
-			glDrawElements(GL_POLYGON, primitiveCount, GL_UNSIGNED_SHORT, indexList);
+			glDrawElements(GL_POLYGON, primitiveCount, GL_UNSIGNED_INT, indexList);
 			break;
 	}
 
@@ -1392,7 +1392,7 @@
 
 
 //! queries the features of the driver, returns true if feature is available
-bool COpenGLDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature)
+bool COpenGLDriver::queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice)
 {
 	switch (feature)
 	{
diff -r -uw -N irrlicht/source/Irrlicht/COpenGLDriver.h irrlicht_multipatch/source/Irrlicht/COpenGLDriver.h
--- irrlicht/source/Irrlicht/COpenGLDriver.h	2006-11-25 13:46:52.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/COpenGLDriver.h	2006-12-05 11:48:50.000000000 +0100
@@ -86,10 +86,10 @@
 		virtual void setTransform(E_TRANSFORMATION_STATE state, const core::matrix4& mat);
 
 		//! draws a vertex primitive list
-		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u16* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
+		void drawVertexPrimitiveList(const void* vertices, s32 vertexCount, const u32* indexList, s32 primitiveCount, E_VERTEX_TYPE vType, scene::E_PRIMITIVE_TYPE pType);
 
 		//! queries the features of the driver, returns true if feature is available
-		bool queryFeature(E_VIDEO_DRIVER_FEATURE feature);
+		bool queryFeature(E_VIDEO_DRIVER_FEATURE feature, s32 renderDevice = -1);
 
 		//! Sets a material. All 3d drawing functions draw geometry now
 		//! using this material.
diff -r -uw -N irrlicht/source/Irrlicht/CSceneManager.cpp irrlicht_multipatch/source/Irrlicht/CSceneManager.cpp
--- irrlicht/source/Irrlicht/CSceneManager.cpp	2006-11-18 08:23:10.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CSceneManager.cpp	2006-12-03 16:22:08.000000000 +0100
@@ -791,6 +791,10 @@
 	}
 }
 
+void CSceneManager::updateEffects()
+{
+	OnUpdateEffect();
+}
 
 //! This method is called just before the rendering process of the whole scene.
 //! draws all scene nodes
@@ -938,10 +942,10 @@
 //! Creates a texture animator, which switches the textures of the target scene
 //! node based on a list of textures.
 ISceneNodeAnimator* CSceneManager::createTextureAnimator(const core::array<video::ITexture*>& textures,
-	s32 timePerFrame, bool loop)
+	s32 timePerFrame, bool loop, s32 layer)
 {
 	ISceneNodeAnimator* anim = new CSceneNodeAnimatorTexture(textures,
-		timePerFrame, loop, os::Timer::getTime());
+		timePerFrame, loop, os::Timer::getTime(), layer);
 
 	return anim;
 }
diff -r -uw -N irrlicht/source/Irrlicht/CSceneManager.h irrlicht_multipatch/source/Irrlicht/CSceneManager.h
--- irrlicht/source/Irrlicht/CSceneManager.h	2006-11-11 09:31:16.000000000 +0100
+++ irrlicht_multipatch/source/Irrlicht/CSceneManager.h	2006-12-03 16:20:52.000000000 +0100
@@ -87,6 +87,9 @@
 		//! registers a node for rendering it at a specific time.
 		virtual void registerNodeForRendering(ISceneNode* node, E_SCENE_NODE_RENDER_PASS = ESNRP_AUTOMATIC);
 
+		//! draws the effect of all scene nodes
+		virtual void updateEffects();
+
 		//! draws all scene nodes
 		virtual void drawAll();
 
@@ -246,7 +249,7 @@
 		//! Creates a texture animator, which switches the textures of the target scene
 		//! node based on a list of textures.
 		virtual ISceneNodeAnimator* createTextureAnimator(const core::array<video::ITexture*>& textures,
-			s32 timePerFrame, bool loop);
+			s32 timePerFrame, bool loop, s32 layer=0);
 
 		//! Creates a scene node animator, which deletes the scene node after
 		//! some time automaticly.
diff -r -uw -N irrlicht/source/Irrlicht/CSceneNodeAnimatorTexture.cpp irrlicht_multipatch/source/Irrlicht/CSceneNodeAnimatorTexture.cpp
--- irrlicht/source/Irrlicht/CSceneNodeAnimatorTexture.cpp	2006-08-29 08:13:02.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CSceneNodeAnimatorTexture.cpp	2006-12-01 13:38:24.000000000 +0100
@@ -12,8 +12,8 @@
 
 //! constructor
 CSceneNodeAnimatorTexture::CSceneNodeAnimatorTexture(const core::array<video::ITexture*>& textures, 
-						 s32 timePerFrame, bool loop, u32 now)
-: Loop(loop), StartTime(now), TimePerFrame(timePerFrame)
+						 s32 timePerFrame, bool loop, u32 now, s32 layer)
+: Loop(loop), StartTime(now), TimePerFrame(timePerFrame), Layer(layer)
 {
 	#ifdef _DEBUG
 	setDebugName("CSceneNodeAnimatorTexture");
@@ -64,7 +64,7 @@
 			idx = (t/TimePerFrame) % Textures.size();
 
 		if (idx < (s32)Textures.size())
-			node->setMaterialTexture(0, Textures[idx]);
+			node->setMaterialTexture(Layer, Textures[idx]);
 	}
 }
 
diff -r -uw -N irrlicht/source/Irrlicht/CSceneNodeAnimatorTexture.h irrlicht_multipatch/source/Irrlicht/CSceneNodeAnimatorTexture.h
--- irrlicht/source/Irrlicht/CSceneNodeAnimatorTexture.h	2006-06-17 08:11:54.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CSceneNodeAnimatorTexture.h	2006-12-01 13:37:32.000000000 +0100
@@ -18,7 +18,7 @@
 
 		//! constructor
 		CSceneNodeAnimatorTexture(const core::array<video::ITexture*>& textures,
-			s32 timePerFrame, bool loop, u32 now);
+			s32 timePerFrame, bool loop, u32 now, s32 layer);
 
 		//! destructor
 		virtual ~CSceneNodeAnimatorTexture();
@@ -44,6 +44,7 @@
 		u32 StartTime;
 		u32 EndTime;
 		bool Loop;
+		s32 Layer;
 	};
 
 
diff -r -uw -N irrlicht/source/Irrlicht/CShadowVolumeSceneNode.cpp irrlicht_multipatch/source/Irrlicht/CShadowVolumeSceneNode.cpp
--- irrlicht/source/Irrlicht/CShadowVolumeSceneNode.cpp	2006-08-29 08:13:00.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CShadowVolumeSceneNode.cpp	2006-11-29 23:36:36.000000000 +0100
@@ -305,7 +305,7 @@
 	if (totalIndices > IndexCountAllocated)
 	{
 		delete [] Indices;
-		Indices = new u16[totalIndices];
+		Indices = new u32[totalIndices];
 		IndexCountAllocated = totalIndices;
 
 		if (UseZFailMethod)
@@ -324,8 +324,8 @@
 		s32 idxcnt = b->getIndexCount();
 		s32 vtxnow = VertexCount;
 
-		const u16* idxp = b->getIndices();
-		const u16* idxpend = idxp + idxcnt;
+		const u32* idxp = b->getIndices();
+		const u32* idxpend = idxp + idxcnt;
 
 		for (; idxp!=idxpend; ++idxp)
 			Indices[IndexCount++] = *idxp + vtxnow;
@@ -443,7 +443,7 @@
 void CShadowVolumeSceneNode::calculateAdjacency(f32 epsilon)
 {
 	delete [] Adjacency;
-	Adjacency = new u16[IndexCount];
+	Adjacency = new u32[IndexCount];
 
 	epsilon *= epsilon;
 
diff -r -uw -N irrlicht/source/Irrlicht/CShadowVolumeSceneNode.h irrlicht_multipatch/source/Irrlicht/CShadowVolumeSceneNode.h
--- irrlicht/source/Irrlicht/CShadowVolumeSceneNode.h	2006-08-29 08:13:00.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CShadowVolumeSceneNode.h	2006-11-29 23:36:34.000000000 +0100
@@ -66,9 +66,9 @@
 		bool UseZFailMethod;
 		core::aabbox3d<f32> Box;
 
-		u16* Indices;
+		u32* Indices;
 		core::vector3df* Vertices;
-		u16* Adjacency;
+		u32* Adjacency;
 		bool* FaceData; // used for zfail method, if face is front facing
 
 		s32 IndexCountAllocated;
